<template>
  <section id="createUser">
    <AlertBox ref="alertBox" />
    <v-card class="mx-auto" max-width="600">
      <v-container three-line>
        <v-row>
          <v-col cols="12" id="email">
            <v-text-field v-model="formUser.email"
                          @keyup.enter="sendUser"
                          :error-messages="emailErrors"
                          label="อีเมล"
                          required
                          clearable />
          </v-col>
          <v-col cols="12" id="password">
            <v-text-field v-model="formUser.password"
                          @keyup.enter="sendUser"
                          :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
                          :type="showPassword ? 'text' : 'password'"
                          :error-messages="passwordErrors"
                          label="รหัสผ่าน"
                          required
                          clearable
                          class="input-group--focused"
                          @click:append="showPassword = !showPassword" />
          </v-col>
          <v-col cols="6" id="firstname">
            <v-text-field v-model="formUser.firstname"
                          @keyup.enter="sendUser"
                          :error-messages="firstNameErrors"
                          label="ชื่อ"
                          required
                          clearable />
          </v-col>
          <v-col cols="6" id="lastname">
            <v-text-field v-model="formUser.lastname"
                          @keyup.enter="sendUser"
                          :error-messages="lastNameErrors"
                          label="นามสกุล"
                          required
                          clearable />
          </v-col>
          <v-col cols="12" id="age">
            <v-text-field v-model="formUser.age"
                          @keyup.enter="sendUser"
                          :error-messages="ageErrors"
                          oninput="this.value=this.value.replace(/^[0a-zA-Z][0-9a-zA-Z]*$/g,'');"
                          label="อายุ"
                          required
                          clearable />
          </v-col>
          <v-col cols="12" id="tel">
            <v-text-field v-model="formUser.tel"
                          @keyup.enter="sendUser"
                          oninput="this.value=this.value.replace(/[^0-9]/g,'');"
                          :error-messages="telErrors"
                          label="เบอร์โทรศัพท์"
                          required
                          clearable />
          </v-col>
          <v-col cols="12">
            <v-textarea
              id="address"
              outlined
              name="input-7-4"
              label="ที่อยู่"
              :error-messages="addressErrors"
              required
              v-model="formUser.address" />
          </v-col>
          <v-col cols="12" class="text-center">
            <v-btn width="250px" height="40px" color="info" dark @click="sendUser" :loading="loadingBeforeCreateUser">สร้างผู้ใช้งาน</v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </section>
</template>

<script>
  import { validationMixin } from "vuelidate";
  import { required, email, minLength, between } from "vuelidate/lib/validators";
  import AlertBox from '~/components/general/alert-box/AlertBox'

  export default {
    name: "create-user",
    components: {
      AlertBox
    },
    mixins: [validationMixin],
    validations: {
      formUser: {
        email: { required, email },
        password: { required, minLength: minLength(6) },
        firstname: { required },
        lastname: { required },
        age: { required, between: between(20, 100) },
        tel: { required, minLength: minLength(10) },
        address: { required }
      }
    },
    computed: {
      emailErrors() {
        const errors = [];
        if (!this.$v.formUser.email.$dirty) return errors
        !this.$v.formUser.email.email && errors.push('กรุณากรอกอีเมลให้ครบถ้วน')
        !this.$v.formUser.email.required && errors.push('กรุณากรอกอีเมล')
        return errors
      },
      passwordErrors() {
        const errors = [];
        if (!this.$v.formUser.password.$dirty) return errors;
        !this.$v.formUser.password.minLength && errors.push('กรุณากรอกรหัสผ่านอย่างน้อย 6 ตัวอักษร')
        !this.$v.formUser.password.required && errors.push("กรุณากรอกรหัสผ่าน");
        return errors;
      },
      firstNameErrors() {
        const errors = [];
        if (!this.$v.formUser.firstname.$dirty) return errors;
        !this.$v.formUser.firstname.required && errors.push("กรุณากรอกชื่อ");
        return errors;
      },
      lastNameErrors() {
        const errors = [];
        if (!this.$v.formUser.lastname.$dirty) return errors;
        !this.$v.formUser.lastname.required && errors.push("กรุณากรอกนามสกุล");
        return errors;
      },
      ageErrors() {
        const errors = [];
        if (!this.$v.formUser.age.$dirty) return errors;
        !this.$v.formUser.age.between && errors.push('กรุณากรอกอายุไม่เกิน 20-100 ปี')
        !this.$v.formUser.age.required && errors.push("กรุณากรอกอายุ");
        return errors;
      },
      telErrors() {
        const errors = [];
        if (!this.$v.formUser.tel.$dirty) return errors;
        !this.$v.formUser.tel.minLength && errors.push('กรุณากรอกเบอร์โทรศัพท์อย่างน้อย 10 ตัวอักษร')
        !this.$v.formUser.tel.required && errors.push("กรุณากรอกเบอร์โทรศัพท์");
        return errors;
      },
      addressErrors() {
        const errors = [];
        if (!this.$v.formUser.address.$dirty) return errors;
        !this.$v.formUser.address.required && errors.push("กรุณากรอกที่อยู่");
        return errors;
      }
    },
    data() {
      return {
        formUser: {
          email: "",
          password: "",
          firstname: "",
          lastname: "",
          age: "",
          tel: "",
          address: ""
        },
        showPassword: false,
        loadingBeforeCreateUser: false,
      }
    },
    methods: {
      showAlert: function (value) {
        const vm = this
        const alert = {
          'mainTitle': value.title,
          'subTitle': value.text,
          'type': value.type,
          'time': value.time,
          'autoClose': value.autoClose,
          'show': value.show
        }
        vm.$refs.alertBox.showBox(alert)
      },
      sendUser() {
        const vm = this
        vm.$v.$touch()
        if (!vm.emailErrors[0] && !vm.passwordErrors[0] && !vm.firstNameErrors[0] &&
          !vm.lastNameErrors[0] && !vm.ageErrors[0] && !vm.telErrors[0] && !vm.addressErrors[0]) {
          vm.loadingBeforeCreateUser = true
          vm.$axios.$post('/user/create-user', vm.formUser)
            .then((res) => {
              vm.formUser.email = ''
              vm.formUser.password = ''
              vm.formUser.firstname = ''
              vm.formUser.lastname = ''
              vm.formUser.age = ''
              vm.formUser.tel = ''
              vm.formUser.address = ''
              this.$v.$reset()
              vm.showAlert({ title: 'สำเร็จ', text: res.data.massage, type: 'success', time: 5, autoClose: true, show: true })
            })
            .catch((e) => {
              if (e.response) {
                vm.showAlert({title: 'ผิดพลาด!', text: e.response.data.messages, type: 'error', time: 5, autoClose: true, show: true})
              }
            })
          .finally(() => {
            vm.loadingBeforeCreateUser = false
          })
        }
      }
    }
  }
</script>

<style scoped>
</style>
